use crate::storage::DynStorageEngine;

use super::GitProvider;

pub struct GitHubGitProvider {
    storage_engine: DynStorageEngine,
}

impl GitHubGitProvider {
    pub fn new(storage_engine: DynStorageEngine) -> Self {
        Self { storage_engine }
    }
}

#[async_trait::async_trait]
impl GitProvider for GitHubGitProvider {
    async fn clone_from_url(&self, url: String) -> eyre::Result<()> {
        let dir = self.storage_engine.allocate_dir().await?;

        tokio::task::spawn_blocking(move || git2::Repository::clone(url.as_str(), dir.path()))
            .await??;

        Ok(())
    }
}
